<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Class: Form</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-8">
	
		<div id="main">
			

	<h1 class="page-title">Class: Form</h1>
<section>

<header>
    
        <h2>
        Form
        </h2>
        
            <div class="class-description"><p>a) call <a href="Form.html#replace">replace</a> with a bunch of json data.<br>
b) <a href="Form.html#load">load</a> parts of your data for potential form editors based on your schema for this data piece<br>
c) <a href="Form.html#show">show</a> loaded form editors<br>
d) call <a href="Form.html#getData">getData</a> to gather all loaded editors data and return it</p>
<p>uses <a href="https://github.com/json-editor/json-editor">json-editor</a></p>
<p>original file slightly modified to allow easier custom styling.<br>
check for CHANGED tag in comments of external/jsoneditor.js</p>
<p><a href="Form.html#confirmChanged">confirmChanged</a> uses <a href="socket.html#.save">socket.save</a> from server.js to potentially save content before replace!</p></div>
        
    
</header>


<article>
    <div class="container-overview">
    
        
<hr>
<dt>
    <h4 class="name" id="Form"><span class="type-signature"></span>new Form()</h4>
    
    
</dt>
<dd>

    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-156">line 156</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

    
    </div>

    

    

    

    

    

    
        <h3 class="subsection-title">Members</h3>

        <dl>
            
<hr>
<dt class="name" id="content">
    <h4 id="content"><span class="type-signature"></span>content<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>recent loaded content</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-158">line 158</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="editors">
    <h4 id="editors"><span class="type-signature"></span>editors<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>currently loaded JSONEditor Objects. Key is string path</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-161">line 161</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="current">
    <h4 id="current"><span class="type-signature"></span>current<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>currently shown JSONEditor</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-164">line 164</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="is_locked">
    <h4 id="is_locked"><span class="type-signature"></span>is_locked<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>disabled/enabled status</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-167">line 167</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="title">
    <h4 id="title"><span class="type-signature"></span>title<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>get identifier for current editor content</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-286">line 286</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="title">
    <h4 id="title"><span class="type-signature"></span>title<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>change title/identifier of current content<br>
if current editor is based on root in current data<br>
move its instance in editors object accordingly</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-296">line 296</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="changed">
    <h4 id="changed"><span class="type-signature"></span>changed<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>has current content changed</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-321">line 321</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="changed">
    <h4 id="changed"><span class="type-signature"></span>changed<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>set changed flag of current content</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-329">line 329</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="collection">
    <h4 id="collection"><span class="type-signature"></span>collection<span class="type-signature"></span></h4>

    
</dt>
<dd>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-336">line 336</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        
            
<hr>
<dt class="name" id="addTab">
    <h4 id="addTab"><span class="type-signature"></span>addTab<span class="type-signature"></span></h4>

    
</dt>
<dd>
    
    <div class="description">
        <p>creates a tab item with event handlers and adds it to the bar element</p>
    </div>
    

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-675">line 675</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    
</dd>

        </dl>
    

    
        <h3 class="subsection-title">Methods</h3>

        <dl>
            
<hr>
<dt>
    <h4 class="name" id="load"><span class="type-signature"></span>load(data [, path], schema)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>load JSON Editor for jsondata</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Argument</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Object.html">Object</a></span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>JS Object the editor is populated with</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            

            <td class="description last"><p>path to content that will be displayed in editor. With no path, editor display all current data</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>schema</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Object.html">Object</a></span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            

            <td class="description last"><p>json schema how data is to be presented</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-177">line 177</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="reportErrors"><span class="type-signature"></span>reportErrors(errors)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>iterate through JSONEditor error message object</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>errors</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Object.html">Object</a></span>



            
            </td>

            

            

            <td class="description last"><p>JSONEditor Error Object</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-237">line 237</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="getData"><span class="type-signature"></span>getData()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>collect data of all current editors.<br>
If data and editor are the same (editor shows everything) replace content.data with editor value</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-265">line 265</a>
			</li>
		</ul>
	</dd>
	

	

	

	
	<dt class="tag-todo method-doc-label method-doc-details-label">To Do:</dt>
	<dd class="tag-todo">
		<ul>
			<li>should validate first</li>
			</ul>
	</dd>
	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>data that was stored including (if there are any) changes</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Object.html">Object</a></span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="show"><span class="type-signature"></span>show(path)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>replace currently diplayed editor with editor in path.<br>
Has to be loaded load before</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>'.' seperated path</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-361">line 361</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="showGraph"><span class="type-signature"></span>showGraph(path)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>show graphical flow editor</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>'.' seperated path</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-388">line 388</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="toggleView"><span class="type-signature"></span>toggleView()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>show the other editor (table or node graph)</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-416">line 416</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="setCurrent"><span class="type-signature"></span>setCurrent(path, value)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>set specific value in currently shown editor<br>
will be immediatly changed in visible form</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>'.' seperated path addressing value in currently displayed editor</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">*</span>



            
            </td>

            

            

            <td class="description last"><p>new value for property on path</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-432">line 432</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="replace"><span class="type-signature"></span>replace(data, collection [, identifier])</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>store json data that is being worked with in this form<br>
(e.g. a level or all x devices)<br>
Interrupt process if there were unsaved changes in current editor data</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Argument</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Object.html">Object</a></span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>json data to work with in form editor</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>collection</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Object.html">Object</a></span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>database collection data was stored in. Obligatory when working with save</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>identifier</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    'name'
                
                </td>
            

            <td class="description last"><p>change key of data object that identifies the data.</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-464">line 464</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="clear"><span class="type-signature"></span>clear()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>remove editor from page and clear current content</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-497">line 497</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>true if successfully cleared</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="discard"><span class="type-signature"></span>discard()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>remove editor from page and clear current content<br>
without asking if content fas changed</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-510">line 510</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="confirmChanged"><span class="type-signature"></span>confirmChanged()</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>check if current working data has changed.<br>
Let user decide what to do.<br>
return if user wants to go back to old data or to go on</p>
<p>uses <a href="socket.html#.save">socket.save</a> from server.js to potentially save content before replace!</p>
    </div>
    

    

    

    
    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-527">line 527</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>true if no changes or user wants to go on. false if user wants to cancel</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Promise</span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="editableTitle"><span class="type-signature"></span>editableTitle(title_text, dom_type, del_btn)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>Title with an edit button that turns it into an input on click</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>title_text</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>text to show on creation</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>dom_type</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>type of dom element the title is wrapped in</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>del_btn</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>



            
            </td>

            

            

            <td class="description last"><p>set to true adds a trash bin button to the title</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-573">line 573</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>the title Element</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Object.html">Object</a></span>



    </dd>
</dl>


        

    
</dd>

        
            
<hr>
<dt>
    <h4 class="name" id="tabrow"><span class="type-signature"></span>tabrow(path, schema)</h4>
    
    
</dt>
<dd>

    
    <div class="description">
        <p>creates a row of tabs with editable titles<br>
loads  editors assigned to tab<br>
each tab opens editor assigned to it</p>
    </div>
    

    

    

    
    
        <h5>Parameters:</h5>
        

<table class="params table table-striped">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>string path to object containing objects that become tabs</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>schema</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Object.html">Object</a></span>



            
            </td>

            

            

            <td class="description last"><p>schema for the content each tab is assigned to</p></td>
        </tr>

    
    </tbody>
</table>

    

    
<dl class="details">
    

	

	

	

    

    

    

    

	

	

	

	

	



	
	<dt class="tag-source method-doc-label method-doc-details-label">Source:</dt>
	<dd class="tag-source">
		<ul class="dummy">
			<li>
				<a href="editor_form.js.html">editor/form.js</a>,
				 <a href="editor_form.js.html#sunlight-1-line-668">line 668</a>
			</li>
		</ul>
	</dd>
	

	

	

	
</dl>


    

    

    

    

    

    
    <h5>Returns:</h5>
    
            
<div class="param-desc">
    <p>tab row container element</p>
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Object.html">Object</a></span>



    </dd>
</dl>


        

    
</dd>

        </dl>
    

    

    
</article>

</section>




		</div>
	</div>

	<div class="clearfix"></div>

	
		<div class="col-md-3">
			<div id="toc" class="col-md-3 hidden-xs hidden-sm hidden-md"></div>
		</div>
	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>